package filter;

use Tk;
use time_dialog;
use POSIX;

 ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = (localtime(time));

 $before_date = strftime("%Y%m%d%H%M",
                      $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst);

 $after_date  = strftime("%Y%m%d%H%M",0,0,0,1,0,80,0,1,0);

 %event_class =  ("Administrative"=>"ad",
                  "Application"=>"ap",
                  "Exec"=>"ex",
                  "File Attribute Access"=>"fw",
                  "File Attribute Modification"=>"fm", 
                  "File Close"=>"cl",
                  "File Create"=>"fc",
                  "File Delete"=>"fd",
                  "File Read"=>"fr",
                  "File Write"=>"fr", 
                  "IPC"=>"ip",  
                  "IOCTL"=>"io", 
                  "Login/Logout"=>"lo",
                  "Network"=>"nt",
                  "Non-attributable"=>"na",    
                  "Process"=>"pc",
                  );

 $filter_set=0;
 $pid=undef;
 $euid="All Users";
 $ruid="All Users";
 $rgid="All Groups";
 $egid="All Groups";
 $audit_trail="-A";
 $timeflag=0;
 $mw="";
 $od="";
 $sd="";
 $x="";
 $y="";
 $save_file="";
 @unselected_items=();
 @selected_items=();

 $events="";

 $selected_items_lb=undef;
 $after_time_filter=undef;
 $before_time_filter=undef;
 
########################
#
#
sub dump_selected_events{

    my @selected=undef;
    my $temp="";
    my $desc=undef;

    @selected_items   = undef;
    @selected_items   = undef;
    @unselected_items = $event_class_lb->get(0,'end');
    @selected_items   = $selected_items_lb->get(0,'end');
  
    $events="";

    if(@selected_items){
	foreach(@selected_items){ 
            $events = $event_class{$_}.",".$events;
	}
    }
    
    $events =~ s/\,$//;

    $before_date = $before_time_filter->dump_values();
    $after_date = $after_time_filter->dump_values();
}

########################
#
#
sub get_filter_params{

    my $param="";
    my @selected="";
    my $mon="";
    my $day="";
    my $year="";
    my $hour="";
    my $minute="";

    if($filter_set==0){
	return "";
    }
   
    $param = $param." -c $events" if $events ne "";
    $param = $param." -e $euid" if defined $euid && $euid ne "All Users";
    $param = $param." -f $egid" if defined $egid && $egid ne "All Groups";
    $param = $param." -r $ruid" if defined $ruid && $ruid ne "All Users";
    $param = $param." -g $rgid" if defined $rgid && $rgid ne "All Groups";
    $param = $param." -o pid=$pid" if defined $pid;

    if($timeflag){
      ($mon,$day,$year,$hour,$minute) = $before_time_filter->dump_values();
      $param = $param." -b ".$year.$mon.$day.$hour.$minute."00";

      ($mon,$day,$year,$hour,$minute) = $after_time_filter->dump_values();
      $param = $param." -a ".$year.$mon.$day.$hour.$minute."00";
    }

    return $param;
}
########################
#
#
sub disable_filter{

    $filter_set = 0;
}
########################
#
#
sub filter_dialog{

    $mt = shift;
    $x = shift;
    $y = shift;

    my $time_widget_x=5;
    my $time_widget_y=5;

    my $event_class_frame_x=5;
    my $event_class_frame_y=120;

    my $event_class_x=15;
    my $event_class_y=10;

    my $p_buttons_frame_x =5;
    my $p_buttons_frame_y = 345;

    my $p_buttons_x = 3;
    my $p_buttons_y = 8;

    my @uid_list="";
    my @gid_list="";
 
    $filter_set=1;    
 
    $mw = $mt->Toplevel();
    $mw->title("Event Filter");
    $mw->geometry("400x500+$x+$y");
    $mw->resizable(0,0);
    $mw->grab();

    $mw->Checkbutton(-text=>'Enable time filter',
                     -variable=>\$timeflag,
                     -command=>sub{ if($timeflag==1){
                                      $after_time_filter->enable_entry();
                                      $before_time_filter->enable_entry(); 
                                    }
                                    else{
                                      $after_time_filter->disable_entry();
                                      $before_time_filter->disable_entry();
                                     
                                    }			     
                                   }
                     
		     )->pack();

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = (localtime(time));

    $date = strftime("%m%d%Y%H%M",
                      $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst);


    $f1 = $mw->Frame(-relief=>'groove',
                    -width=>180,
                    -height=>90,
                    -borderwidth=>2)->place(-x=>5,-y=>25);

    if(!defined($after_time_filter)){
	$after_time_filter= time_dialog->new($after_date);
    }
   
    $f1->Label(-text=>"View Events From")->place(-x=>$time_widget_x,
                                                 -y=>$time_widget_y);

    $after_time_filter->time_dialog($f1,$time_widget_x,$time_widget_y+25);
  
    $f2 = $mw->Frame(-relief=>'groove',
                     -width=>180,
                     -height=>90,
                     -borderwidth=>2)->place(-x=>213,-y=>25);

    if(!defined($before_time_filter)){
      $before_time_filter =time_dialog->new($before_date);
    }

    $f2->Label(-text=>"View Events Through")->place(-x=>$time_widget_x,
                                                    -y=>$time_widget_y);
  
   $before_time_filter->time_dialog($f2,$time_widget_x,$time_widget_y+25);    

    if ($timeflag==0){
      $after_time_filter->disable_entry();
      $before_time_filter->disable_entry();                              
    }


    $f3 = $mw->Frame(-relief=>'groove',
                    -width=>390,
                    -height=>220,
                    -borderwidth=>2)->place(-x=>$event_class_frame_x,
                                            -y=>$event_class_frame_y);

    $f3->Label(-text=>"Event Classes")->place(-x=>$event_class_x,
                                              -y=>$event_class_y);

    $event_class_lb = $f3->Scrolled("Listbox",
                                    -selectmode=>"single",
                                    -selectmode => "extended",
                                    -scrollbars => "osoe")
	->place(-x=>$event_class_x,-y=>$event_class_y+15,
                -width=>150,-height=>150);

    if(defined(@unselected_items)){
	populate_list_box($event_class_lb,@unselected_items);
    }
    else{
        @list = ();
        build_event_list(\@list); 
        populate_list_box($event_class_lb,@list);
    }

    $f3->Label(-text=>"Selected Event Classes")->place(-x=>$event_class_x+175,
                                                       -y=>$event_class_y);

    $selected_items_lb = $f3->Scrolled("Listbox",
				    -selectmode=>"single",
                                    -selectmode => "extended",
                                    -scrollbars => "osoe")
	->place(-x=>$event_class_x+175,
                -y=>$event_class_y+15,-width=>150,-height=>150);

    if(defined(@selected_items)){
	populate_list_box($selected_items_lb,@selected_items);
    }

    $f3->Button(-text=>"Select",
		-command=>sub{ @selected = ();
                               @selected = $event_class_lb->curselection();
                               @items= $selected_items_lb->get(0,'end');
                         loop: 
                               foreach(@selected){
                                 foreach $i (@items){ 
				   next loop if $event_class_lb->get($_) eq $i;
		                 }
	            
				 $selected_items_lb->insert('end',
			         $event_class_lb->get($_));
                               }
			   })->place(-x=>$event_class_x,
                                     -y=>$event_class_y+175);

    $f3->Button(-text=>"Unselect",
		-command=>sub{ @selected= ();
                               @selected = $selected_items_lb->curselection();
			
                               $count=0;
                               foreach(@selected){
	                         $index = $_ - $count;
                                 $count++;
	        		 $selected_items_lb->delete($index);
                               }
			     })->place(-x=>$event_class_x+175,
                                       -y=>$event_class_y+175);
  
  
    $f4 = $mw->Frame(-relief=>'groove',
                    -width=>390,
                    -height=>75,
                    -borderwidth=>2)->place(-x=>$p_buttons_frame_x,
                                            -y=>$p_buttons_frame_y);


    $f4->Label(-text=>"PID:")->place(-x=>$p_buttons_x,-y=>$p_buttons_y);
    $f4->Entry(-width=>8,-textvariable=>\$pid)->place(-x=>$p_buttons_x+35,
                                                      -y=>$p_buttons_y);

    $f4->Label(-text=>"EUID:")->place(-x=>$p_buttons_x+105,
                                      -y=>$p_buttons_y);

    $f4->Button(-textvariable=>\$euid,
		-relief=>'raised',
                -command=>sub{display_picker("UID",\$euid);})
	->place(-x=>$p_buttons_x+145,-y=>$p_buttons_y-4);

    $f4->Label(-text=>"RUID:")->place(-x=>$p_buttons_x+240,
                                      -y=>$p_buttons_y);
              
    $f4->Button(-textvariable=>\$ruid,
	        -relief=>'raised',
                -command=>sub{display_picker("UID",\$ruid);})
	->place(-x=>$p_buttons_x+280,-y=>$p_buttons_y-4);
    
    $f4->Label(-text=>"EGID:")->place(-x=>$p_buttons_x+105,
                                      -y=>$p_buttons_y+30);

    $f4->Button(-textvariable=>\$egid,
		-relief=>'raised',
                -command=>sub{display_picker("GID",\$egid);})
	->place(-x=>$p_buttons_x+145,-y=>$p_buttons_y+26);
      
    $f4->Label(-text=>"RGID:")->place(-x=>$p_buttons_x+240,
                                      -y=>$p_buttons_y+30);

    $f4->Button(-textvariable=>\$rgid,
       	        -relief=>'raised',
                -command=>sub{display_picker("GID",\$rgid);})
	->place(-x=>$p_buttons_x+280,-y=>$p_buttons_y+26);
   

    $f5 = $mw->Frame(-relief=>'groove',
                    -width=>390,
                    -height=>45,
                    -borderwidth=>2)->place(-x=>5,
                                            -y=>430);

    $b1 = $f5->Button(-text=>"OK",
                      -width=>10,
		      -command=>sub{dump_selected_events();$mw->destroy();})
->place(-x=>50,-y=>5);
 
    $b2 = $f5->Button(-text=>"Cancel",
                      -width=>10,
                -command=> sub { $mw->destroy();})
	->place(-x=>250,-y=>5);



    MainLoop;           
}

#######################
#
#
sub populate_list_box{

    my $lb = shift;
    $lb->insert('end',@_);  
}

#######################
#
#
sub build_event_list{

    my $event_list=shift;
   
    foreach $class (sort keys %event_class){
	push(@$event_list,$class);
    }

}
#######################
#
#
sub display_picker{

    my $md = $mt->Toplevel();
    $md->title("Select");
    
    my $x = $mw->x();
    my $y = $mw->y();

    $md->geometry("+$x+$y");
    $md->resizable(0,0);
    my @data=();
  
    $data_type = shift;
    $p = shift;
   
    if($data_type eq "UID"){
      @data = build_uid_list();
    }
    else{
      @data = build_gid_list();
    }
 
    $lb = $md->Scrolled("Listbox",
                        -scrollbars=>"e",
                        -selectmode=>"single")->pack();
 
    $md->Button(-text=>"OK",-command=>sub{$sel = $lb->curselection();
                                          $$p = $lb->get($sel);
                                          $md->destroy();})->pack();

    populate_list_box($lb,@data);
  
    $lb->selectionSet(0);

    $md->grab();
}
#######################
#
#
sub build_uid_list{

    my $i=0;
    my @list="";
    my @L;
    $list[$i++]="All Users";
    while(($name,$passwd,$uid) = getpwent){
	$list[$i++] = $name;
    }
    endpwent;
    return(sort(@list));  
}

#######################
#
#
sub build_gid_list{

    my $i=0;
    my @list="";

    $list[$i++]= "All Groups";
    while(($name,$passwd,$gid,$members) = getgrent){
	$list[$i++] = $name;
    }
    endgrent;
    return(sort(@list));
}


1































