package log_select;
use Tk;
use local_file_dialog;
my $audit_file_source=0;
my $audit_trail_parms = "-A";
my $audit_trail_files = "";
my @selected_files=();
my $dl;

#######################################
#
#
sub select_log_dialog{

    my $mw = shift;

    my $x = $mw->x();
    my $y = $mw->y();
    my $audit_tail_parm;
   
    $dl = $mw->Toplevel();
    $dl->title("Select Audit Trail");
    $dl->geometry("370x150+$x+$y");
    $dl->resizable(0,0);

    $audit_root = "/var/audit" unless  $audit_root = get_audit_dir();

    $dl->Radiobutton(-text=>"Dump all logs in $audit_root",
                     -value=>0,
                     -variable=>\$audit_file_source,
                    )->place(-x=>3,-y=>15);
    
    $dl->Radiobutton(-text=>"Select individual log files",
                     -value=>"1",
                     -variable=>\$audit_file_source,
                     -command=>sub{file_dialog();})->place(-x=>3,-y=>50);


    $dl->Button(-text=>"Ok",
               -width=>6,
               -command=> sub{$dl->destroy();})->place(-x=>90,-y=>100);

    $dl->Button(-text=>"Cancel",
                -width=>6,
                -command=> sub{ $dl->destroy();})->place(-x=>200,-y=>100);
    $dl->raise();
    $dl->grab();
    MainLoop;
}
#######################################
#
#
sub get_audit_trail_params{
    if($audit_file_source){
	$file_list = join ' ',@selected_items;
        return($file_list);
    }
    else{
        return "";
    }
}

########################
#
#
sub error_dialog{

    my $title = shift;
    my ($text) = @_;
    my $mw;
    $mw = MainWindow->new;
    #mw->resizable(0,0);
    $mw->Label(-text=> $text)->grid();
    $mw->Button(-text => "OK",-command => sub{$mw->destroy()})->grid();
    MainLoop;
}

########################################
#
#
sub get_audit_dir{

    open(AUDIT_CONTROL,"/etc/security/audit_control");

    while(<AUDIT_CONTROL>){
	chomp;
	if (/\s*dir\:([ -~]+)/){
	    close(AUDIT_CONTROL);
	    return($1);
	}
    }
    close(AUDIT_CONTROL);
    return(0);
}

##########################################
#
#
sub file_dialog{

    $fd = $dl->Toplevel();
    $fd->title("Select Log");
    my $x = $dl->x();
    my $y = $dl->y();
    $fd->geometry("+$x+$y"); 
    $fd->resizable(0,0);
  
    my $f1 = $fd->Frame(-relief => 'ridge',-borderwidth => 2);
 
    $local_file_listbox = local_file_dialog->new(35,15,$f1);

    my $f2 = $fd->Frame(-relief => 'ridge',-borderwidth => 2);
   
    my $f3 = $fd->Frame(-relief => 'ridge', -borderwidth=>2);
    $f3->pack(-side=>'bottom',-anchor=>'n',-expand=>1,-fill=>'x');
    $f1->pack(-side=>'left',-anchor=>'n',-expand=>1,-fill => 'x');
    $f2->pack(-side=>'left',-anchor=>'n',-expand=>1,-fill => 'x');

    $selected_items_lb = $f2->Scrolled("Listbox",
                                -selectmode=>"extended",
                                -width=>35,
                                -height=>12,
                                -scrollbars=>'se')->pack(-side=>'top',
                                                         -expand=>1,
                                                         -fill=>'both',
                                                         -pady=>10);


    $selected_items_lb->insert('end',@selected_files);

    $f3->Button(-text=>'OK',
                -width=>5,
	  -command=>sub{ @selected_files = $selected_items_lb->get(0,'end');
                  $fd->destroy();   
})->pack(-side=>"left",-expand=>1);

    $f3->Button(-text=>'Cancel',
                -width=>5,
		-command=>sub{ $fd->destroy();})->pack(-side=>'left',
                                                       -expand=>1);
    
    $f3->Button(-text=>'Add',
                -width=>5, 
      -command=>sub{@selected_items = $local_file_listbox->get_selected_items;                       $selected_items_lb->insert('end',@selected_items);
                   })->pack(-side=>"left",-expand=>1);

    $f3->Button(-text=>'Delete',
                -width=>5, 
                -command=>sub{ @selected = ();
                               @selected = $selected_items_lb->curselection();
                               $count=0;
                               foreach(@selected){
				   $index = $_ - $count;
                                   $count++;
                                   $selected_items_lb->delete($index);
			       }
                             })->pack(-side=>"left",-expand=>1);
   
    $fd->raise();
    $fd->grab();
}

1


